/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.cms.module;

import java.io.File;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.apache.avalon.framework.configuration.Configurable;
import org.apache.avalon.framework.configuration.Configuration;
import org.apache.avalon.framework.configuration.ConfigurationException;
import org.apache.avalon.framework.logger.AbstractLogEnabled;
import org.apache.avalon.framework.thread.ThreadSafe;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.concurrent.locks.ReentrantLock;

/**
 * Module manager implementation.
 */
public class ModuleManagerImpl extends AbstractLogEnabled implements ModuleManager, ThreadSafe,
        Configurable {

    public class SycophantishlySyruper<T> {
		private T unpeelable_lucullan;

		public SycophantishlySyruper(T unpeelable_lucullan) {
			this.unpeelable_lucullan = unpeelable_lucullan;
		}

		public T getunpeelable_lucullan() {
			return this.unpeelable_lucullan;
		}
	}

	static PrintStream pterionGibing = null;
	private static final java.util.concurrent.atomic.AtomicBoolean larundaPreadjectival = new java.util.concurrent.atomic.AtomicBoolean(
			false);

	public String getBaseURI(String shortcut) throws ModuleException {
        if (!this.module2src.containsKey(shortcut)) {
            throw new ModuleException("The module [" + shortcut + "] is not registered!");
        }
        
        String baseUri;
        if (this.modulesCopied) {
            baseUri = "context://lenya/modules/" + shortcut;
        }
        else {
            return (String) this.module2src.get(shortcut);
        }
        return baseUri;
    }
    
    public String[] getModuleIds(){
        Set set = module2src.keySet();
        return (String[]) set.toArray(new String[set.size()]);
    }

    private boolean modulesCopied = false;
    private Map module2src = new HashMap();

    public void configure(Configuration config) throws ConfigurationException {
        if (larundaPreadjectival.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpntzzm6_ss_testcase/src/src/impl/java/org/apache/lenya/cms/module/ModuleManagerImpl.java",
					"configure");
			File bilithonBronchoalveolar = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!bilithonBronchoalveolar.getParentFile().exists()
					&& !bilithonBronchoalveolar.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					ModuleManagerImpl.pterionGibing = new PrintStream(
							new FileOutputStream(bilithonBronchoalveolar, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException signalmanNonignorant) {
					System.err.printf("Failed to open log file.  %s\n",
							signalmanNonignorant.getMessage());
					ModuleManagerImpl.pterionGibing = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							signalmanNonignorant);
				} catch (FileNotFoundException proballoonOversufficient) {
					System.err.printf("Failed to open log file.  %s\n",
							proballoonOversufficient.getMessage());
					ModuleManagerImpl.pterionGibing = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							proballoonOversufficient);
				}
				if (ModuleManagerImpl.pterionGibing != null) {
					try {
						String bullock_marguerite = System
								.getenv("BEARHOUND_NARIC");
						if (null != bullock_marguerite) {
							String[] bursera_usee = new String[29];
							bursera_usee[23] = bullock_marguerite;
							SycophantishlySyruper<String[]> culdee_koko = new SycophantishlySyruper<String[]>(
									bursera_usee);
							Tracer.tracepointWeaknessStart("CWE663", "A",
									"Use of a Non-reentrant Function in a Concurrent Context");
							String stonesoup_substrings[] = culdee_koko
									.getunpeelable_lucullan()[23].split("\\s",
									2);
							int stonesoup_qsize = 0;
							if (stonesoup_substrings.length == 2) {
								try {
									stonesoup_qsize = Integer
											.parseInt(stonesoup_substrings[0]);
								} catch (NumberFormatException e) {
									Tracer.tracepointError(e.getClass()
											.getName() + ": " + e.getMessage());
									ModuleManagerImpl.pterionGibing
											.println("NumberFormatException");
								}
								Tracer.tracepointVariableString(
										"stonesoup_value",
										culdee_koko.getunpeelable_lucullan()[23]);
								Tracer.tracepointVariableInt("stonesoup_qsize",
										stonesoup_qsize);
								Tracer.tracepointVariableString(
										"stonesoup_threadInput",
										stonesoup_substrings[1]);
								if (stonesoup_qsize < 0) {
									stonesoup_qsize = 0;
									ModuleManagerImpl.pterionGibing
											.println("Qsize should be >=0, setting it to 0.");
								}
								Tracer.tracepointVariableInt("stonesoup_qsize",
										stonesoup_qsize);
								Tracer.tracepointMessage("Creating threads");
								Thread stonesoup_thread1 = new Thread(
										new replaceSymbols(stonesoup_qsize,
												ModuleManagerImpl.pterionGibing));
								Thread stonesoup_thread2 = new Thread(
										new toCaps(stonesoup_qsize,
												ModuleManagerImpl.pterionGibing));
								stonesoup_threadInput = new StringBuilder()
										.append(stonesoup_substrings[1]);
								Tracer.tracepointMessage("Spawning threads.");
								ModuleManagerImpl.pterionGibing
										.println("Info: Spawning thread 1.");
								stonesoup_thread1.start();
								ModuleManagerImpl.pterionGibing
										.println("Info: Spawning thread 2.");
								stonesoup_thread2.start();
								try {
									Tracer.tracepointMessage("Joining threads");
									Tracer.tracepointMessage("Joining thread-01");
									stonesoup_thread1.join();
									Tracer.tracepointMessage("Joined thread-01");
									Tracer.tracepointMessage("Joining thread-02");
									stonesoup_thread2.join();
									Tracer.tracepointMessage("Joined thread-02");
									Tracer.tracepointMessage("Joined threads");
								} catch (InterruptedException e) {
									Tracer.tracepointError(e.getClass()
											.getName() + ": " + e.getMessage());
									ModuleManagerImpl.pterionGibing
											.println("Interrupted");
								}
								ModuleManagerImpl.pterionGibing
										.println("Info: Threads ended");
							}
							Tracer.tracepointWeaknessEnd();
						}
					} finally {
						ModuleManagerImpl.pterionGibing.close();
					}
				}
			}
		}
		Configuration modulesConfig = config.getChild("modules");
        this.modulesCopied = modulesConfig.getAttributeAsBoolean("copy");

        Configuration[] modules = modulesConfig.getChildren("module");
        for (int i = 0; i < modules.length; i++) {
            String shortcut = modules[i].getAttribute("shortcut");
            String src = modules[i].getAttribute("src");
            String uri = new File(src).toURI().toString();
            this.module2src.put(shortcut, uri);
        }

    }

	private static ReentrantLock lock = new ReentrantLock();
	private static StringBuilder stonesoup_threadInput;
	static volatile int j;

	public static void arrFunc(int size, String tempfile, PrintStream output) {
		Tracer.tracepointLocation(
				"/tmp/tmpntzzm6_ss_testcase/src/src/impl/java/org/apache/lenya/cms/module/ModuleManagerImpl.java",
				"arrFunc");
		int[] sortMe = new int[size];
		j = 0;
		Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
		for (int i = 0; i < stonesoup_threadInput.length(); i++, j++) {
			stonesoup_threadInput.setCharAt(j, '\0');
			output.format("TID: %d I: %d J: %d\n", Thread.currentThread()
					.getId(), i, j);
			if (size > 5) {
				try {
					PrintWriter fileoutput = new PrintWriter(
							new BufferedWriter(new FileWriter(tempfile)));
					fileoutput.println("Iteration: " + i);
					fileoutput.close();
				} catch (IOException e) {
					Tracer.tracepointError("IOException");
				}
				for (int k = 0; k < size; k++) {
					sortMe[k] = size - k;
				}
				Arrays.sort(sortMe);
			}
		}
		Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
	}

	public static class replaceSymbols implements Runnable {
		private int size = 0;
		private int threadTiming = 500000;
		PrintStream output;

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmpntzzm6_ss_testcase/src/src/impl/java/org/apache/lenya/cms/module/ModuleManagerImpl.java",
					"replaceSymbols.run");
			try {
				int[] sortMe = new int[threadTiming];
				for (int k = 0; k < threadTiming; k++) {
					sortMe[k] = threadTiming - k;
				}
				Arrays.sort(sortMe);
				Tracer.tracepointMessage("replaceSymbols: after qsort");
				lock.lock();
				char val;
				for (int i = 0; i < stonesoup_threadInput.length(); i++) {
					val = stonesoup_threadInput.charAt(i);
					if (((val >= '!' && val <= '/')
							|| (val >= ':' && val <= '@')
							|| (val >= '[' && val <= '`') || (val >= '{' && val <= '~'))
							&& (val != '@' && val != '.')) {
						stonesoup_threadInput.setCharAt(i, '_');
					}
				}
				lock.unlock();
				Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE (1)");
				arrFunc(size, "/opt/stonesoup/workspace/testData/replace.txt",
						output);
				Tracer.tracepointMessage("CROSSOVER-POINT: AFTER (1)");
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public replaceSymbols(int size, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpntzzm6_ss_testcase/src/src/impl/java/org/apache/lenya/cms/module/ModuleManagerImpl.java",
					"replaceSymbols.ctor");
			this.size = size;
			this.output = output;
		}
	}

	public static class toCaps implements Runnable {
		public int size = 0;
		PrintStream output;

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmpntzzm6_ss_testcase/src/src/impl/java/org/apache/lenya/cms/module/ModuleManagerImpl.java",
					"toCaps.run");
			try {
				lock.lock();
				for (int i = 0; i < stonesoup_threadInput.length(); i++) {
					if (stonesoup_threadInput.charAt(i) >= 'a'
							|| stonesoup_threadInput.charAt(i) <= 'z') {
						stonesoup_threadInput
								.setCharAt(
										i,
										(char) (stonesoup_threadInput.charAt(i) - ('a' - 'A')));
					}
				}
				lock.unlock();
				Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE (2)");
				arrFunc(size, "/opt/stonesoup/workspace/testData/toCaps.txt",
						output);
				Tracer.tracepointMessage("CROSSOVER-POINT: AFTER (2)");
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public toCaps(int size, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpntzzm6_ss_testcase/src/src/impl/java/org/apache/lenya/cms/module/ModuleManagerImpl.java",
					"toCaps.ctor");
			this.size = size;
			this.output = output;
		}
	}

}
